Index: /trunk/XTIDE_Universal_BIOS/Inc/BootVars.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/BootVars.inc	(revision 499)
+++ /trunk/XTIDE_Universal_BIOS/Inc/BootVars.inc	(revision 500)
@@ -57,5 +57,5 @@
 struc HOTKEYVARS
 	.wTimeToClose		resb	2		; Earliest system time when Hotkey Bar can be closed
-	.wHddAndFddLetters:
+	.wFddAndHddLetters:
 	.bFddLetter			resb	1		; Floppy Drive letter hotkey (upper case)
 	.bHddLetter			resb	1		; Hard Drive letter hotkey (upper case)
Index: /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 499)
+++ /trunk/XTIDE_Universal_BIOS/Inc/RomVars.inc	(revision 500)
@@ -134,8 +134,8 @@
 
 DEVICE_ATA_TERTIARY_PORT				EQU		1E8h
-DEVICE_ATA_TERTIARY_PORTCTRL			EQU		(DEVICE_ATA_TERTIARY_PORT + STANDARD_CONTROL_BLOCK_OFFSET)
+DEVICE_ATA_TERTIARY_PORTCTRL			EQU		((DEVICE_ATA_TERTIARY_PORT + STANDARD_CONTROL_BLOCK_OFFSET) & ~0Fh)	; 3E0h
 
 DEVICE_ATA_QUATERNARY_PORT				EQU		168h
-DEVICE_ATA_QUATERNARY_PORTCTRL			EQU		(DEVICE_ATA_QUATERNARY_PORT + STANDARD_CONTROL_BLOCK_OFFSET)
+DEVICE_ATA_QUATERNARY_PORTCTRL			EQU		((DEVICE_ATA_QUATERNARY_PORT + STANDARD_CONTROL_BLOCK_OFFSET) & ~0Fh)	; 360h
 
 
Index: /trunk/XTIDE_Universal_BIOS/Src/Menus/HotkeyBar.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/Menus/HotkeyBar.asm	(revision 499)
+++ /trunk/XTIDE_Universal_BIOS/Src/Menus/HotkeyBar.asm	(revision 500)
@@ -66,6 +66,4 @@
 ;--------------------------------------------------------------------
 .PrintFloppyDriveHotkeys:
-	mov		cx, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.wHddAndFddLetters]
-		
 	call	FloppyDrive_GetCountToAX
 	test	ax, ax		; Any Floppy Drives?
@@ -73,4 +71,5 @@
 
 	mov		ax, (ANGLE_QUOTE_RIGHT << 8) | DEFAULT_FLOPPY_DRIVE_LETTER
+	mov		cl, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bFddLetter]
 	mov		di, g_szFDD
 	call	FormatDriveHotkeyString
@@ -91,5 +90,5 @@
 	call	DriveXlate_GetLetterForFirstHardDriveToAX
 	mov		ah, ANGLE_QUOTE_RIGHT
-	mov		cl, ch
+	mov		cl, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bHddLetter]
 	mov		di, g_szHDD
 	call	FormatDriveHotkeyString
@@ -229,5 +228,6 @@
 	;;  fall through to PushHotkeyParamsAndFormat 
 
-%else ; MODULE_BOOT_MENU - No boot menu so use simpler attributes
+
+%else ; if no MODULE_BOOT_MENU - No boot menu so use simpler attributes
 
 	mov		dx, (COLOR_ATTRIBUTE(COLOR_YELLOW, COLOR_CYAN) << 8) | MONO_REVERSE_BLINK
@@ -238,8 +238,8 @@
 
 SelectAttributeFromDHorDLbasedOnVideoMode:
-	mov		al, [es:BDA.bVidMode]
-	shr		al, 1
+	mov		ch, [es:BDA.bVidMode]		; We only need to preserve CL
+	shr		ch, 1
 	jnc		SHORT .AttributeLoadedToDL	; Black & White modes
-	shr		al, 1
+	shr		ch, 1
 	jnz		SHORT .AttributeLoadedToDL	; MDA
 	mov		dl, dh
@@ -253,6 +253,6 @@
 ; PushHotkeyParamsAndFormat
 ;	Parameters:
-;		BL:			First character
-;		BH:			Second character
+;		AL:			First character
+;		AH:			Second character
 ;		DX:			Description Attribute
 ;		CX:			Description string parameter
@@ -406,5 +406,5 @@
 ;--------------------------------------------------------------------
 HotkeyBar_GetBootDriveNumbersToDX:
-	mov		dx, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.wHddAndFddLetters]
+	mov		dx, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.wFddAndHddLetters]
 	test	BYTE [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bFlags], FLG_HOTKEY_HD_FIRST		
 	jnz		.noflip
Index: /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/BootVars.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/BootVars.asm	(revision 499)
+++ /trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/BootVars.asm	(revision 500)
@@ -64,5 +64,5 @@
 ;--------------------------------------------------------------------
 BootVars_StoreHotkeyForDriveNumberInDL:
-	mov		WORD [es:BOOTVARS.hotkeyVars+HOTKEYVARS.wHddAndFddLetters], DEFAULT_FLOPPY_DRIVE_LETTER | (DEFAULT_HARD_DRIVE_LETTER<<8)
+	mov		WORD [es:BOOTVARS.hotkeyVars+HOTKEYVARS.wFddAndHddLetters], DEFAULT_FLOPPY_DRIVE_LETTER | (DEFAULT_HARD_DRIVE_LETTER<<8)
 	call	DriveXlate_ConvertDriveNumberFromDLtoDriveLetter
 	jmp		HotkeyBar_StoreHotkeyToBootvarsForDriveLetterInDL