Index: trunk/XTIDE_Universal_BIOS/Src/Menus/HotkeyBar.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Menus/HotkeyBar.asm	(revision 500)
+++ trunk/XTIDE_Universal_BIOS/Src/Menus/HotkeyBar.asm	(revision 505)
@@ -34,6 +34,6 @@
 	call	HotkeyBar_ScanHotkeysFromKeyBufferAndStoreToBootvars
 	; Fall to HotkeyBar_DrawToTopOfScreen
-		
-		
+
+
 ;--------------------------------------------------------------------
 ; HotkeyBar_DrawToTopOfScreen
@@ -127,5 +127,5 @@
 	call	FormatFunctionHotkeyString
 %endif
-	; Fall to .PrintRomBootHotkey		
+	; Fall to .PrintRomBootHotkey
 
 ;--------------------------------------------------------------------
@@ -169,11 +169,10 @@
 ;--------------------------------------------------------------------
 HotkeyBar_ClearRestOfTopRow:
-	CALL_DISPLAY_LIBRARY	GetColumnsToALandRowsToAH
+	CALL_DISPLAY_LIBRARY GetColumnsToALandRowsToAH
 	eMOVZX	cx, al
-	CALL_DISPLAY_LIBRARY	GetSoftwareCoordinatesToAX
+	CALL_DISPLAY_LIBRARY GetSoftwareCoordinatesToAX
 	sub		cl, al
 	mov		al, ' '
-	CALL_DISPLAY_LIBRARY	PrintRepeatedCharacterFromALwithCountInCX
-	ret
+	JMP_DISPLAY_LIBRARY PrintRepeatedCharacterFromALwithCountInCX
 
 
@@ -216,5 +215,5 @@
 
 	mov		si, ATTRIBUTE_CHARS.cHurryTimeout		; Selected hotkey
-	jz		SHORT GetDescriptionAttributeToDX		; From compare with bScancode above
+	je		SHORT GetDescriptionAttributeToDX		; From compare with bScancode above
 
 GetNonSelectedHotkeyDescriptionAttributeToDX:
@@ -226,5 +225,5 @@
 	call	MenuAttribute_GetToAXfromTypeInSI
 	xchg	dx, ax					; DX = Description attribute
-	;;  fall through to PushHotkeyParamsAndFormat 
+	;;  fall through to PushHotkeyParamsAndFormat
 
 
@@ -232,5 +231,5 @@
 
 	mov		dx, (COLOR_ATTRIBUTE(COLOR_YELLOW, COLOR_CYAN) << 8) | MONO_REVERSE_BLINK
-	jz		SHORT SelectAttributeFromDHorDLbasedOnVideoMode			; From compare with bScancode above
+	je		SHORT SelectAttributeFromDHorDLbasedOnVideoMode		; From compare with bScancode above
 
 GetNonSelectedHotkeyDescriptionAttributeToDX:
@@ -245,5 +244,5 @@
 	mov		dl, dh
 .AttributeLoadedToDL:
-	;;  fall through to PushHotkeyParamsAndFormat 		
+	;;  fall through to PushHotkeyParamsAndFormat
 
 %endif ; MODULE_BOOT_MENU
@@ -277,5 +276,5 @@
 	push	di				; Description string
 	push	cx				; Description string parameter
-		
+
 	push	si				; Key attribute for last space
 
@@ -308,6 +307,5 @@
 ;--------------------------------------------------------------------
 HotkeyBar_RestoreCursorCoordinatesFromAX:
-	CALL_DISPLAY_LIBRARY	SetCursorCoordinatesFromAX
-	ret
+	JMP_DISPLAY_LIBRARY SetCursorCoordinatesFromAX
 
 
@@ -325,5 +323,5 @@
 HotkeyBar_StoreHotkeyToBootvarsForDriveLetterInDL:
 	eMOVZX	ax, dl
-	xor		al, 32	; Upper case drive letter to lower case keystroke
+	or		al, 32	; Upper case drive letter to lower case keystroke
 	jmp		SHORT HotkeyBar_StoreHotkeyToBootvarsIfValidKeystrokeInAX
 
@@ -364,11 +362,11 @@
 	; All scancodes are saved, even if it wasn't a drive letter,
 	; which also covers our function key case.  Invalid function keys
-	; will not do anything (won't be printed, won't be accepted as input)		
+	; will not do anything (won't be printed, won't be accepted as input)
 	mov		[es:di], ah
-		
+
 	; Drive letter hotkeys remaining, allow 'a' to 'z'
 	call	Char_IsLowerCaseLetterInAL
 	jnc		SHORT .KeystrokeIsNotValidDriveLetter
-	xor		al, 32					; We want to print upper case letters
+	and		al, ~32					; We want to print upper case letters
 
 	; Clear HD First flag to assume Floppy Drive hotkey
@@ -377,5 +375,5 @@
 
 	; Determine if Floppy or Hard Drive hotkey
-	eMOVZX	cx, al					; Clear CH to clear scancode
+	xchg	cx, ax
 	call	DriveXlate_GetLetterForFirstHardDriveToAX
 	cmp		cl, al
@@ -386,9 +384,9 @@
 
 .StoreDriveLetter:
-	sbb		di, BYTE 1			; Sub CF if Floppy Drive
+	sbb		di, BYTE 1				; Sub CF if Floppy Drive
 	xchg	ax, cx
-	mov		[es:di], al			; AH = zero to clear function hotkey
-
-.KeystrokeIsNotValidDriveLetter:		
+	mov		[es:di], al
+
+.KeystrokeIsNotValidDriveLetter:
 NoHotkeyToProcess:
 	mov		al, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bScancode]
@@ -407,12 +405,12 @@
 HotkeyBar_GetBootDriveNumbersToDX:
 	mov		dx, [es:BOOTVARS.hotkeyVars+HOTKEYVARS.wFddAndHddLetters]
-	test	BYTE [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bFlags], FLG_HOTKEY_HD_FIRST		
+	test	BYTE [es:BOOTVARS.hotkeyVars+HOTKEYVARS.bFlags], FLG_HOTKEY_HD_FIRST
 	jnz		.noflip
 	xchg	dl, dh
-.noflip:	
+.noflip:
 	call	DriveXlate_ConvertDriveLetterInDLtoDriveNumber
 	xchg	dl, dh
-	; Fall to HotkeyBar_FallThroughTo_DriveXlate_ConvertDriveLetterInDLtoDriveNumber		
-		
-HotkeyBar_FallThroughTo_DriveXlate_ConvertDriveLetterInDLtoDriveNumber:		
-
+	; Fall to HotkeyBar_FallThroughTo_DriveXlate_ConvertDriveLetterInDLtoDriveNumber
+
+HotkeyBar_FallThroughTo_DriveXlate_ConvertDriveLetterInDLtoDriveNumber:
+