Index: trunk/XTIDE_Universal_BIOS/Inc/HotkeyBar.inc
===================================================================
--- trunk/XTIDE_Universal_BIOS/Inc/HotkeyBar.inc	(revision 505)
+++ trunk/XTIDE_Universal_BIOS/Inc/HotkeyBar.inc	(revision 506)
@@ -21,5 +21,5 @@
 %define HOTKEYBAR_INC
 
-MIN_TIME_TO_DISPLAY_HOTKEY_BAR			EQU	(5000/55)	; 5000 ms
+MIN_TIME_TO_DISPLAY_HOTKEY_BAR			EQU	(3000/55)	; 3000 ms
 
 ROM_BOOT_HOTKEY_SCANCODE				EQU	42h	; F8
Index: trunk/XTIDE_Universal_BIOS/Inc/Version.inc
===================================================================
--- trunk/XTIDE_Universal_BIOS/Inc/Version.inc	(revision 505)
+++ trunk/XTIDE_Universal_BIOS/Inc/Version.inc	(revision 506)
@@ -42,5 +42,5 @@
 
 %define	TITLE_STRING			TITLE_STRING_START, TITLE_STRING_END
-%define	ROM_VERSION_STRING		"v2.0.0",BETA,"2+ (",__DATE__,")",NULL
+%define	ROM_VERSION_STRING		"v2.0.0",BETA,"3 (",__DATE__,")",NULL
 %define	FLASH_SIGNATURE			"XTIDE203"	; Do not terminate with NULL
 
@@ -58,5 +58,5 @@
 #define BETA " Beta "
 
-#define ROM_VERSION_STRING		"v2.0.0" BETA "2 (" __DATE__ ")"
+#define ROM_VERSION_STRING		"v2.0.0" BETA "3 (" __DATE__ ")"
 
 /*
Index: trunk/XTIDE_Universal_BIOS/Src/Main.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 505)
+++ trunk/XTIDE_Universal_BIOS/Src/Main.asm	(revision 506)
@@ -64,5 +64,5 @@
 
 ; ROM variables (must start at offset 0)
-CNT_ROM_BLOCKS		EQU		ROMSIZE / 512		; number of 512B blocks, 16 = 8kB BIOS
+CNT_ROM_BLOCKS		EQU		BIOS_SIZE / 512		; number of 512B blocks, 16 = 8kB BIOS
 istruc ROMVARS
 	at	ROMVARS.wRomSign,	dw	0AA55h			; PC ROM signature
Index: trunk/XTIDE_Universal_BIOS/makefile
===================================================================
--- trunk/XTIDE_Universal_BIOS/makefile	(revision 505)
+++ trunk/XTIDE_Universal_BIOS/makefile	(revision 506)
@@ -96,10 +96,10 @@
 # Assembler preprocessor defines.                               #
 #################################################################
-DEFINES_COMMON = MODULE_STRINGS_COMPRESSED MODULE_HOTKEYS MODULE_EBIOS MODULE_FEATURE_SETS RESERVE_DIAGNOSTIC_CYLINDER
-DEFINES_COMMON_LARGE = MODULE_BOOT_MENU MODULE_8BIT_IDE MODULE_8BIT_IDE_ADVANCED
-
-DEFINES_XT = $(DEFINES_COMMON) ELIMINATE_CGA_SNOW MODULE_8BIT_IDE MODULE_SERIAL MODULE_SERIAL_FLOPPY
+DEFINES_COMMON = MODULE_STRINGS_COMPRESSED MODULE_HOTKEYS MODULE_8BIT_IDE MODULE_SERIAL MODULE_SERIAL_FLOPPY MODULE_EBIOS MODULE_FEATURE_SETS RESERVE_DIAGNOSTIC_CYLINDER
+DEFINES_COMMON_LARGE = MODULE_BOOT_MENU MODULE_8BIT_IDE_ADVANCED
+
+DEFINES_XT = $(DEFINES_COMMON) ELIMINATE_CGA_SNOW MODULE_8BIT_IDE_ADVANCED
 DEFINES_XTPLUS = $(DEFINES_COMMON) $(DEFINES_XT) USE_186
-DEFINES_AT = $(DEFINES_COMMON) USE_AT USE_286 USE_UNDOC_INTEL RELOCATE_INT13H_STACK MODULE_IRQ MODULE_SERIAL MODULE_SERIAL_FLOPPY MODULE_ADVANCED_ATA
+DEFINES_AT = $(DEFINES_COMMON) USE_AT USE_286 USE_UNDOC_INTEL RELOCATE_INT13H_STACK MODULE_IRQ MODULE_ADVANCED_ATA
 
 DEFINES_XT_LARGE = $(DEFINES_XT) $(DEFINES_COMMON_LARGE)
@@ -118,16 +118,18 @@
 
 # Target size of the ROM, used in main.asm for number of 512B blocks and by checksum Perl script below
-ROMSIZE = 8192
-ROMSIZE_LARGE = 15360
+BIOS_SIZE = 8192		# For BIOS header (use even multiplier!)
+ROMSIZE = $(BIOS_SIZE)	# Size of binary to build when building with make checksum
+BIOS_SIZE_LARGE = 10240
+ROMSIZE_LARGE = $(BIOS_SIZE_LARGE)
 
 # Add -D in front of every preprocessor define declaration
-DEFS_XT = $(DEFINES_XT:%=-D%) -DROMSIZE=$(ROMSIZE)
-DEFS_XTPLUS = $(DEFINES_XTPLUS:%=-D%) -DROMSIZE=$(ROMSIZE)
-DEFS_AT = $(DEFINES_AT:%=-D%) -DROMSIZE=$(ROMSIZE)
-DEFS_XT_LARGE = $(DEFINES_XT_LARGE:%=-D%) -DROMSIZE=$(ROMSIZE_LARGE)
-DEFS_XTPLUS_LARGE = $(DEFINES_XTPLUS_LARGE:%=-D%) -DROMSIZE=$(ROMSIZE_LARGE)
-DEFS_AT_LARGE = $(DEFINES_AT_LARGE:%=-D%) -DROMSIZE=$(ROMSIZE_LARGE)
-DEFS_XT_TINY = $(DEFINES_XT_TINY:%=-D%) -DROMSIZE=$(ROMSIZE)
-DEFS_386_8K = $(DEFINES_386_8K:%=-D%) -DROMSIZE=$(ROMSIZE)
+DEFS_XT = $(DEFINES_XT:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
+DEFS_XTPLUS = $(DEFINES_XTPLUS:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
+DEFS_AT = $(DEFINES_AT:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
+DEFS_XT_LARGE = $(DEFINES_XT_LARGE:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_LARGE)
+DEFS_XTPLUS_LARGE = $(DEFINES_XTPLUS_LARGE:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_LARGE)
+DEFS_AT_LARGE = $(DEFINES_AT_LARGE:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_LARGE)
+DEFS_XT_TINY = $(DEFINES_XT_TINY:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
+DEFS_386_8K = $(DEFINES_386_8K:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
 DEFS_ALL_FEATURES = $(DEFINES_ALL_FEATURES:%=-D%)
 
@@ -171,32 +173,32 @@
 
 small: xt_tiny xt xtplus at 386_8k
-	@echo All 8 kiB binaries built!
+	@echo All small binaries built!
 
 large: xt_large xtplus_large at_large
-	@echo All 15 kiB binaries built!
+	@echo All large binaries built!
 
 at:
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_AT) -l"$(TARGET)_at.lst" -o"$(TARGET)_at.bin"
-	@echo * 8k AT version "$(TARGET)_at.bin" built.
+	@echo * Small AT version "$(TARGET)_at.bin" built.
 
 at_large:
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_AT_LARGE) -l"$(TARGET)_atl.lst" -o"$(TARGET)_atl.bin"
-	@echo *15k AT version "$(TARGET)_atl.bin" built.
+	@echo *Large AT version "$(TARGET)_atl.bin" built.
 
 xtplus:
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XTPLUS) -l"$(TARGET)_xtp.lst" -o"$(TARGET)_xtp.bin"
-	@echo * 8k XT Plus version "$(TARGET)_xtp.bin" built.
+	@echo * Small XT Plus version "$(TARGET)_xtp.bin" built.
 
 xtplus_large:
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XTPLUS_LARGE) -l"$(TARGET)_xtpl.lst" -o"$(TARGET)_xtpl.bin"
-	@echo *15k XT Plus version "$(TARGET)_xtpl.bin" built.
+	@echo *Large XT Plus version "$(TARGET)_xtpl.bin" built.
 
 xt:
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XT) -l"$(TARGET)_xt.lst" -o"$(TARGET)_xt.bin"
-	@echo * 8k XT version "$(TARGET)_xt.bin" built.
+	@echo * Small XT version "$(TARGET)_xt.bin" built.
 
 xt_large:
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XT_LARGE) -l"$(TARGET)_xtl.lst" -o"$(TARGET)_xtl.bin"
-	@echo *15k XT version "$(TARGET)_xtl.bin" built.
+	@echo *Large XT version "$(TARGET)_xtl.bin" built.
 
 xt_tiny:
@@ -206,5 +208,5 @@
 386_8k:
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_386_8K) -l"$(TARGET)_386.lst" -o"$(TARGET)_386.bin"
-	@echo * 8k 386 version "$(TARGET)_386.bin" built.
+	@echo * Small 386 version "$(TARGET)_386.bin" built.
 
 strings: src\Strings.asm