Index: trunk/Serial_Server/library/Checksum.cpp
===================================================================
--- trunk/Serial_Server/library/Checksum.cpp	(revision 505)
+++ trunk/Serial_Server/library/Checksum.cpp	(revision 526)
@@ -6,6 +6,6 @@
 
 //
-// XTIDE Universal BIOS and Associated Tools 
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+// XTIDE Universal BIOS and Associated Tools
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
@@ -13,21 +13,21 @@
 // the Free Software Foundation; either version 2 of the License, or
 // (at your option) any later version.
-// 
+//
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.		
+// GNU General Public License for more details.
 // Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 //
 
 //
-// This file implements Fletcher's Checksum.  The serial code uses this checksum, as it is very quick 
+// This file implements Fletcher's Checksum.  The serial code uses this checksum, as it is very quick
 // to calculate in assembly and offers reasonable error detection.
 // For more information, see http://en.wikipedia.org/wiki/Fletcher%27s_checksum.
 //
-// Since it is faster in 8088 assembly code to deal with 16-bit quantities than 8-bit quantities, 
+// Since it is faster in 8088 assembly code to deal with 16-bit quantities than 8-bit quantities,
 // Fletcher's Checksum has been modified to calculate the 32-bit checksum, and then "fold" the result into a
-// 16-bit quantity.  Fletcher's 32-bit Checksum consists of two parts: concatenated 16-bit accumulators.  
-// To "fold" to 16-bits, The upper and lower 8-bits of each of these accumulators is XOR'd independently, and then 
+// 16-bit quantity.  Fletcher's 32-bit Checksum consists of two parts: concatenated 16-bit accumulators.
+// To "fold" to 16-bits, The upper and lower 8-bits of each of these accumulators is XOR'd independently, and then
 // the two results concatenated together, resulting in 16-bits.  Although simpler, an early attempt to XOR the
 // 16-bit accumulators results in poorer error detection behavior.  Folding as described here results in error
@@ -35,5 +35,5 @@
 //
 // With #define CHECKSUM_TEST, this file becomes a self-contained command line program that runs
-// some statistical tests comparing various checksum algorithms with random 512-byte sectors and various 
+// some statistical tests comparing various checksum algorithms with random 512-byte sectors and various
 // levels of errors introduced.
 //
@@ -58,5 +58,5 @@
 	b = (b & 0xffff) + (b >> 16);
 
-// Although tempting to use, for its simplicity and size/speed in assembly, the following folding 
+// Although tempting to use, for its simplicity and size/speed in assembly, the following folding
 // algorithm results in many undetected single bit errors and therefore should not be used.
 //	return( (unsigned short) (a ^ b) );
@@ -68,5 +68,5 @@
 
 //====================================================================================================
-// 
+//
 // Test Code
 //
@@ -82,5 +82,5 @@
 unsigned char bit[] = { 1, 2, 4, 8, 16, 32, 64, 128 };
 
-class algorithm 
+class algorithm
 {
 public:
@@ -113,5 +113,5 @@
 
 //----------------------------------------------------------------------------------------------------
-// 
+//
 // Standard CRC-16
 //
@@ -131,5 +131,5 @@
 		unsigned short j;
 
-		for(i = 0; i < 256; ++i) 
+		for(i = 0; i < 256; ++i)
 		{
 			value = 0;
@@ -147,5 +147,5 @@
 	}
 
-	unsigned short checksum( unsigned char *data, int len );  
+	unsigned short checksum( unsigned char *data, int len );
 
 private:
@@ -158,5 +158,5 @@
 	int i;
 
-	for(i = 0; i < len; ++i) 
+	for(i = 0; i < len; ++i)
 	{
 		unsigned char index = (unsigned char)(crc ^ data[i]);
@@ -168,5 +168,5 @@
 
 //----------------------------------------------------------------------------------------------------
-// 
+//
 // Basic checksum (just add up the bytes)
 //
@@ -175,5 +175,5 @@
 {
 public:
-	unsigned short checksum( unsigned char *data, int len );  
+	unsigned short checksum( unsigned char *data, int len );
 	basic_algorithm( algorithm *last ) : algorithm( last, (char *) "basic" ) { };
 };
@@ -193,5 +193,5 @@
 {
 public:
-	unsigned short checksum( unsigned char *data, int len );  
+	unsigned short checksum( unsigned char *data, int len );
 	fletcher16_algorithm( algorithm *last ) : algorithm( last, (char *) "f-16" ) { }
 };
@@ -213,5 +213,5 @@
 
 //----------------------------------------------------------------------------------------------------
-// 
+//
 // Folded Fletcher's Checksum (what we use in the serial code, from the top of this file)
 //
@@ -220,5 +220,5 @@
 {
 public:
-	unsigned short checksum( unsigned char *data, int len );  
+	unsigned short checksum( unsigned char *data, int len );
 	folded_fletcher32_algorithm( algorithm *last ) : algorithm( last, (char *) "fold-f-32" ) { }
 };
@@ -230,5 +230,5 @@
 
 //----------------------------------------------------------------------------------------------------
-// 
+//
 // Test Driver and Support routines
 //
@@ -283,10 +283,10 @@
 	{
 		a->found = (unsigned long *) calloc( BUCKETS, sizeof(long) );
-		
+
 		a->zero = (unsigned long) a->checksum( bbuff, BBUFF_LENGTH );
 
 		a->min = iterations+1;
 	}
-	
+
 	printf( "\n" );
 	PRINTROW( "zero   ", "%10d  ", a->zero );
@@ -344,5 +344,5 @@
 
 			bbuff[ rand() % 512 ] ^= bit[ rand() % 8 ];
-			
+
 			if( b > 0 )
 			{
@@ -354,5 +354,5 @@
 			}
 		}
-	}  
+	}
 
 	printf( "\nbit change test:\n" );
Index: trunk/Serial_Server/library/File.h
===================================================================
--- trunk/Serial_Server/library/File.h	(revision 505)
+++ trunk/Serial_Server/library/File.h	(revision 526)
@@ -6,14 +6,14 @@
 //
 // Routines for accessing the file system using generic routines, which
-// should work on all systems.  The issue with using these is that 
+// should work on all systems.  The issue with using these is that
 // ftell() and fseek() are limited to 2 GB files (signed 32-bit quantities)
-// and there is no standard for 64-bit quantities.  So, look for a 
-// OS specific version of this file in the distribution, such as 
+// and there is no standard for 64-bit quantities.  So, look for a
+// OS specific version of this file in the distribution, such as
 // win32/win32file.h which may be in use instead.
-// 
+//
 
 //
-// XTIDE Universal BIOS and Associated Tools 
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+// XTIDE Universal BIOS and Associated Tools
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
@@ -21,9 +21,9 @@
 // the Free Software Foundation; either version 2 of the License, or
 // (at your option) any later version.
-// 
+//
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.		
+// GNU General Public License for more details.
 // Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 //
@@ -44,10 +44,10 @@
 			return( 0 );
 		}
-		
+
 		if( !(fp = fopen( p_name, "w" )) )
 			log( -1, "Could not create file '%s'", p_name );
 
 		name = p_name;
-		
+
 		return( 1 );
 	}
@@ -108,5 +108,5 @@
 	}
 
-	const static unsigned long MaxSectors = 4194303;  // limited by signed 32-bit file sizes 
+	const static unsigned long MaxSectors = 4194303;  // limited by signed 32-bit file sizes
 #define USAGE_MAXSECTORS "2048 MB (signed 32-bit file size limit)"
 
Index: trunk/Serial_Server/library/FlatImage.h
===================================================================
--- trunk/Serial_Server/library/FlatImage.h	(revision 505)
+++ trunk/Serial_Server/library/FlatImage.h	(revision 526)
@@ -7,6 +7,6 @@
 
 //
-// XTIDE Universal BIOS and Associated Tools 
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+// XTIDE Universal BIOS and Associated Tools
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
@@ -14,9 +14,9 @@
 // the Free Software Foundation; either version 2 of the License, or
 // (at your option) any later version.
-// 
+//
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.		
+// GNU General Public License for more details.
 // Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 //
@@ -47,5 +47,5 @@
 			sizef = size / 2048.0;   // 512 byte sectors -> MB
 			sizeChar = 'M';
-			if( sizef < 1 ) 
+			if( sizef < 1 )
 			{
 				sizef *= 1024;
@@ -58,5 +58,5 @@
 				while( size-- )
 					cf.Write( &buff[0], 512 );
-				
+
 				if( p_cyl > 1024 )
 					log( 0, "Created file '%s', size %.2lf %cB", name, sizef, sizeChar );
Index: trunk/Serial_Server/library/Image.cpp
===================================================================
--- trunk/Serial_Server/library/Image.cpp	(revision 505)
+++ trunk/Serial_Server/library/Image.cpp	(revision 526)
@@ -7,6 +7,6 @@
 
 //
-// XTIDE Universal BIOS and Associated Tools 
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+// XTIDE Universal BIOS and Associated Tools
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
@@ -14,9 +14,9 @@
 // the Free Software Foundation; either version 2 of the License, or
 // (at your option) any later version.
-// 
+//
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.		
+// GNU General Public License for more details.
 // Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 //
@@ -28,5 +28,5 @@
 #include <stdio.h>
 
-struct floppyInfo floppyInfos[] = 
+struct floppyInfo floppyInfos[] =
 {
 	{ 1, 2949120 / 512, 6, 80, 2, 36 },   		// 2.88MB 3.5"
@@ -89,5 +89,5 @@
 		shortFileName = "SerDrive";
 	}
-  
+
 	readOnly = p_readOnly;
 	drive = p_drive;
@@ -135,5 +135,5 @@
 			log( -1, "'%s', file size does not match standard CHS geometry (x:16:63), please specify geometry explicitly with -g", name );
 		}
-		else 
+		else
 		{
 			sect = 63;
@@ -151,5 +151,5 @@
 	sizef = totallba/2048.0;
 	sizeChar = 'M';
-	if( sizef < 1 ) 
+	if( sizef < 1 )
 	{
 		sizef *= 1024;
@@ -160,5 +160,5 @@
 			 name, (floppy ? "Floppy Disk" : "Hard Disk"), cyl, head, sect, sizef, sizeChar );
 	else
-		log( 0, "%s: %s with %lu LBA sectors, size %.2lf %cB (CHS geometry %u:%u:%u)", 
+		log( 0, "%s: %s with %lu LBA sectors, size %.2lf %cB (CHS geometry %u:%u:%u)",
 			 name, (floppy ? "Floppy Disk" : "Hard Disk"), totallba, sizef, sizeChar, cyl, head, sect );
 }
@@ -176,5 +176,5 @@
 	*h = '\0';
 	h++;
-	for( s = h+1; *s && *s != ':' && *s != 'x' && *s != 'X'; s++ ) ; 
+	for( s = h+1; *s && *s != ':' && *s != 'x' && *s != 'X'; s++ ) ;
 	if( !*s )
 		return( 0 );
@@ -244,13 +244,13 @@
 	unsigned char com;
 };
-struct comPorts supportedComPorts[] = 
-{ 
-  { 0x3f8, '1' }, 
-  { 0x2f8, '2' }, 
-  { 0x3e8, '3' }, 
-  { 0x2e8, '4' }, 
-  { 0x2f0, '5' }, 
-  { 0x3e0, '6' }, 
-  { 0x2e0, '7' }, 
+struct comPorts supportedComPorts[] =
+{
+  { 0x3f8, '1' },
+  { 0x2f8, '2' },
+  { 0x3e8, '3' },
+  { 0x2e8, '4' },
+  { 0x2f0, '5' },
+  { 0x3e0, '6' },
+  { 0x2e0, '7' },
   { 0x260, '8' },
   { 0x368, '9' },
@@ -258,5 +258,5 @@
   { 0x360, 'B' },
   { 0x270, 'C' },
-  { 0, 0 } 
+  { 0, 0 }
 };
 
@@ -310,5 +310,5 @@
 	}
 
-	// We echo back the port and baud that we were called on from the client, 
+	// We echo back the port and baud that we were called on from the client,
 	// the client then uses this value to finalize the DPT.
 	//
@@ -321,5 +321,5 @@
 	buff[ ATA_wSerialDriveFlags ] = ATA_wSerialDriveFlags_Present;
 	if( floppy )
-		buff[ ATA_wSerialDriveFlags ] |= 
+		buff[ ATA_wSerialDriveFlags ] |=
 			ATA_wSerialDriveFlags_Floppy | (floppyType << ATA_wSerialDriveFlags_FloppyType_FieldPosition);
 
Index: trunk/Serial_Server/library/Library.h
===================================================================
--- trunk/Serial_Server/library/Library.h	(revision 505)
+++ trunk/Serial_Server/library/Library.h	(revision 526)
@@ -7,6 +7,6 @@
 
 //
-// XTIDE Universal BIOS and Associated Tools 
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+// XTIDE Universal BIOS and Associated Tools
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
@@ -14,9 +14,9 @@
 // the Free Software Foundation; either version 2 of the License, or
 // (at your option) any later version.
-// 
+//
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.		
+// GNU General Public License for more details.
 // Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 //
Index: trunk/Serial_Server/library/Process.cpp
===================================================================
--- trunk/Serial_Server/library/Process.cpp	(revision 505)
+++ trunk/Serial_Server/library/Process.cpp	(revision 526)
@@ -7,6 +7,6 @@
 
 //
-// XTIDE Universal BIOS and Associated Tools 
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+// XTIDE Universal BIOS and Associated Tools
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
@@ -14,9 +14,9 @@
 // the Free Software Foundation; either version 2 of the License, or
 // (at your option) any later version.
-// 
+//
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.		
+// GNU General Public License for more details.
 // Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 //
@@ -179,5 +179,5 @@
 		lasttick = GetTime();
 
-		// 
+		//
 		// No work currently to do, look at each character as they come in...
 		//
@@ -289,7 +289,7 @@
 				if( (workCommand != SERIAL_COMMAND_INQUIRE) && (buff.chs.driveAndHead & ATA_COMMAND_LBA) )
 				{
-					mylba = ((((unsigned long) buff.lba.bits24) & ATA_COMMAND_HEADMASK) << 24) 
-						| (((unsigned long) buff.lba.bits16) << 16) 
-						| (((unsigned long) buff.lba.bits08) << 8) 
+					mylba = ((((unsigned long) buff.lba.bits24) & ATA_COMMAND_HEADMASK) << 24)
+						| (((unsigned long) buff.lba.bits16) << 16)
+						| (((unsigned long) buff.lba.bits08) << 8)
 						| ((unsigned long) buff.lba.bits00);
 				}
@@ -346,5 +346,5 @@
 				readto = 514;
 			}
-			else 
+			else
 			{
 				//
@@ -355,5 +355,5 @@
 					unsigned char localScan;
 
-					if( serial->speedEmulation && 
+					if( serial->speedEmulation &&
 						buff.inquire.baud != serial->baudRate->divisor )
 					{
@@ -363,9 +363,9 @@
 					}
 
-					localScan = buff.inquire.scan;         // need to do this before the call to 
+					localScan = buff.inquire.scan;         // need to do this before the call to
 					                                       // img->respondInquire, as it will clear the buff
-					img->respondInquire( &buff.w[0], buff.inquirePacked.PackedPortAndBaud, 
-										 serial->baudRate, 
-										 ((unsigned short) buff.inquire.port) << 2, 
+					img->respondInquire( &buff.w[0], buff.inquirePacked.PackedPortAndBaud,
+										 serial->baudRate,
+										 ((unsigned short) buff.inquire.port) << 2,
 										 (img == image1 && lastScan) || buff.inquire.scan );
 					lastScan = localScan;
Index: trunk/Serial_Server/library/Serial.cpp
===================================================================
--- trunk/Serial_Server/library/Serial.cpp	(revision 505)
+++ trunk/Serial_Server/library/Serial.cpp	(revision 526)
@@ -7,6 +7,6 @@
 
 //
-// XTIDE Universal BIOS and Associated Tools 
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+// XTIDE Universal BIOS and Associated Tools
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
@@ -14,9 +14,9 @@
 // the Free Software Foundation; either version 2 of the License, or
 // (at your option) any later version.
-// 
+//
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.		
+// GNU General Public License for more details.
 // Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 //
@@ -26,6 +26,6 @@
 #include <string.h>
 
-struct baudRate supportedBaudRates[] = 
-{ 
+struct baudRate supportedBaudRates[] =
+{
 	{   2400,  0x30,    "2400" },
 	{   4800,  0x18,    "4800" },
@@ -47,5 +47,5 @@
 {
 	struct baudRate *b;
-  
+
 	unsigned long a = atol( str );
 	if( a )
@@ -63,5 +63,5 @@
 	struct baudRate *b;
 
-	for( b = supportedBaudRates; b->rate && b->divisor != divisor; b++ ) 
+	for( b = supportedBaudRates; b->rate && b->divisor != divisor; b++ )
 		;
 
Index: trunk/Serial_Server/win32/Win32.cpp
===================================================================
--- trunk/Serial_Server/win32/Win32.cpp	(revision 505)
+++ trunk/Serial_Server/win32/Win32.cpp	(revision 526)
@@ -7,9 +7,9 @@
 // This file contains the entry point for the Win32 version of the server.
 // It also handles log reporting, timers, and command line parameter parsing.
-// 
-
-//
-// XTIDE Universal BIOS and Associated Tools 
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+//
+
+//
+// XTIDE Universal BIOS and Associated Tools
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
@@ -17,9 +17,9 @@
 // the Free Software Foundation; either version 2 of the License, or
 // (at your option) any later version.
-// 
+//
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.		
+// GNU General Public License for more details.
 // Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 //
@@ -37,8 +37,8 @@
 char *bannerStrings[] = {
 	"SerDrive - XTIDE Universal BIOS Serial Drive Server",
-	"Copyright (C) 2012 by XTIDE Universal BIOS Team",
+	"Copyright (C) 2012-2013 by XTIDE Universal BIOS Team",
 	"Released under GNU GPL v2, with ABSOLUTELY NO WARRANTY",
 	ROM_VERSION_STRING,
-	"", 
+	"",
 	NULL };
 
@@ -58,5 +58,5 @@
 	"",
 	"  -n [megabytes]      Create new disk with given size or use -g geometry",
-	"                      Maximum size is " USAGE_MAXSECTORS, 
+	"                      Maximum size is " USAGE_MAXSECTORS,
 	"                      Floppy images can also be created, such as \"360K\"",
 	"                      (default is a 32 MB disk, with CHS geometry 65:16:63)",
@@ -152,5 +152,5 @@
 		    char *c;
 			unsigned long a;
-			for( c = &argv[t][1]; *c && !isdigit( *c ); c++ ) 
+			for( c = &argv[t][1]; *c && !isdigit( *c ); c++ )
 				;
 			a = atol(c);
@@ -190,5 +190,5 @@
 				if( !baudRate )
 					baudRate = baudRateMatchString( "115200" );
-				break;			  
+				break;
 			case 'g': case 'G':
 				if( next && atol(next) != 0 )
Index: trunk/Serial_Server/win32/Win32File.h
===================================================================
--- trunk/Serial_Server/win32/Win32File.h	(revision 505)
+++ trunk/Serial_Server/win32/Win32File.h	(revision 526)
@@ -13,5 +13,5 @@
 //
 // XTIDE Universal BIOS and Associated Tools
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
Index: trunk/Serial_Server/win32/Win32Serial.h
===================================================================
--- trunk/Serial_Server/win32/Win32Serial.h	(revision 505)
+++ trunk/Serial_Server/win32/Win32Serial.h	(revision 526)
@@ -7,6 +7,6 @@
 
 //
-// XTIDE Universal BIOS and Associated Tools 
-// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+// XTIDE Universal BIOS and Associated Tools
+// Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team.
 //
 // This program is free software; you can redistribute it and/or modify
@@ -14,9 +14,9 @@
 // the Free Software Foundation; either version 2 of the License, or
 // (at your option) any later version.
-// 
+//
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// GNU General Public License for more details.		
+// GNU General Public License for more details.
 // Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 //